<?php

class Bootstrap extends Zend_Application_Bootstrap_Bootstrap
{
	/**
	 * Set the html DocType as STRICT 
	 */
	protected function _initDoctype()
	{
		$this->bootstrap('view');
		$view = $this->getResource('view');
		$view->doctype('XHTML1_STRICT');
	}
	
	/**
	 * Define the namespace and resourse for modules
	 */
	protected function _initAutoload()
	{
		$autoloader = new Zend_Application_Module_Autoloader(array(
			'namespace' => 'VSCAN',
			'basePath'  => APPLICATION_PATH . '/modules/default/' ,
			'resourceTypes' => array (
				'model' => array(
					'path' => 'models',
					'namespace' => 'Model',
				),
				'mappers' => array (
					'path' => 'models/Mapper/',
					'namespace' => 'Mapper',
				),
				'filters' => array(
					'path' => 'filters',
					'namespace' => 'Filter',
				),
				'forms' => array(
					'path' => 'forms',
					'namespace' => 'Form',
				)
			),
		));
		return $autoloader;
	}
	
	/**
	 * Registred Config on a static singleton, to be retrieved from any where 
	 * 
	 */
 	protected function _initConfig()
	{
	    $config = new Zend_Config($this->getOptions(), true);
	    Zend_Registry::set('config', $config);
	}
	
	protected function _initCache()
	{
         $frontendOptions = array( 
            'lifetime' => 0, // cache lifetime of 2 hours 
            'automatic_serialization' => true
         );

         $cachedir = APPLICATION_PATH .'/../cache';
         $backendOptions = array( 
            'cache_dir' => $cachedir,
         ); 

         $cache = Zend_Cache::factory('Output', 
                              'File', 
                              $frontendOptions, 
                              $backendOptions); 
         Zend_Registry::set(VSCAN_Cache::CACHE_NAME, $cache);
         Zend_Db_Table_Abstract::setDefaultMetadataCache(VSCAN_Cache::CACHE_NAME);
         return $cache; 

	}
	
	/**
	 * 
	 * Init plugins (these act over controller events)
	 */
	protected function _initPlugins()
	{
		$front = Zend_Controller_Front::getInstance();
		$front->registerPlugin(new VSCAN_Plugin_Auth());
		Zend_Session::start();
	}

	protected function _initTimeZone(){
		date_default_timezone_set( Zend_Registry::get('config')->date->timezone);
	}
	
	
}
