<?php
class Zend_View_Helper_BootstrapMenu extends Zend_View_Helper_Abstract {
	public function BootstrapMenu(array $pages) {
		$html = array ('<ul class="nav">' );
		
		foreach ( $pages as $page ) {
			// visibility of the page
			if (! $page->isVisible ()) {
				continue;
			}
			$classes = "";
			// dropdown
			$dropdown = ! empty ( $page->pages );
			$classes .= ($dropdown ? 'dropdown' : '');
			$classes .= ($page->isActive () ? ' active' : '');
			$classes .= " " . $page->getClass ();
			
			// header 
			$html [] = '<li class="' . $classes . '" >';
			$html [] = '<a href="' . ($dropdown ? '#' : $page->getHref ()) . '" ' . 'class="dropdown-toggle" data-toggle="dropdown"><i class="' . $page->icon . '"></i>';
			$html [] = $page->getLabel ();
			
			if ($dropdown) {
				$html [] = '<b class="caret"></b>';
			}
			
			$html [] = '</a>';
			
			if (! $dropdown) {
				$html [] = '</li>';
				continue;
			}
			
			$html [] = '<ul class="dropdown-menu">';
			
			foreach ( $page->pages as $subpage ) {
				// visibility of the sub-page
				if (! $subpage->isVisible ()) {
					continue;
				}
				$classes = "";
				$classes .= ($page->isActive () ? ' active' : '');
				$classes .= " " . $page->getClass ();
				$html [] = '<li class="' . $classes . '" >';
				$html [] = '<a href="' . $subpage->getHref () . '">';
				
				if ($subpage->get ( 'icon' )) {
					$html [] = '<i class="icon-' . $subpage->get ( 'icon' ) . '"></i>';
				}
				
				$html [] = $subpage->getLabel ();
				$html [] = "</a>";
				$html [] = "</li>";
			}
			
			$html [] = "</ul>";
			$html [] = "</li>";
		}
		
		$html [] = '</ul>';
		
		return join ( PHP_EOL, $html );
	}
}