<?php
class Zend_View_Helper_ListViewTable extends Zend_View_Helper_Abstract
{
	protected $_view;
	public function setView(Zend_View_Interface $view)
	{
		$this->_view = $view;
	}		
	
	/**
	 * 
	 * Render the listView for a table with the given elements to show
	 * @param array $elementsToUse
	 * @param array $elementsToShow
	 */
	public function listViewTable($elementsToUse,  $elementsToShow = array()) {		
		if (is_array($elementsToUse) && count($elementsToUse)) {
			if (!is_array($elementsToShow) || (count($elementsToShow) <= 0)) {
				//if the $elementsToShow param is not set all fields will be shown
				$elementsToShow = array();
				$fields = $elementsToUse[0]->toArray();
				foreach ($fields as $key => $value) {
					$elementsToShow[$key] = ucfirst(str_replace('_', ' ', $key));
				}
			} else {
				//if the $elementsToShow param is set as a vector array we create the map array 
				foreach ($elementsToShow as $key => $value) {
					if(is_int($key)){
						$elementsToShow[$value] = ucfirst(str_replace('_', ' ', $value));
						unset($elementsToShow[$key]);
					}
				}
			}
			$_htmlTableAdmin='';
			$_htmlTableAdmin='<table class="grid">
								<thead>
									<tr class="tr_head">' . $this->showHeader($elementsToShow) . '</tr>
								</thead>
								<tbody>' . $this->showBody($elementsToUse, $elementsToShow) . '</tbody>
							</table>';
			return $_htmlTableAdmin;
		} else {
			return $this->_view->textMessage()->messageError("Empty");
		}
	}
	
	protected function showHeader($headerToShow){
		$outputHeader = '';

		foreach($headerToShow as $key => $value){
			$fieldName = str_replace('_', ' ', $key);
			switch ($key) {
				case "id":
					$outputHeader .= "<th class=\"hidden\">" . $value . "</th>";
					break;
				case "user":
					$outputHeader .= "<th class=\"hidden\">" . $value . "</th>";
					break;
				default:
					$outputHeader .= "<th>" . $value . "</th>";
			}
        }  	
        return $outputHeader;
	}
	
	protected function showBody($bodyToUse, $bodyToShow)
	{
		$output = '';
		$i = 0;
		foreach ($bodyToUse as $valueOfBody){
			$fieldsBody = $valueOfBody->toArray();
			$typeClasseRow = (($i%2) == 0) ? 'even':'';
			$i++;
			$output .= '<tr class="tr_body_' . $typeClasseRow . '">';	
			foreach ($bodyToShow as $key => $value) {
				if(isset($fieldsBody[$key])){
					if (is_object($fieldsBody[$key])) {
						if(method_exists($fieldsBody[$key], "getName")) {
							$fieldsBody[$key]=$fieldsBody[$key]->name;
						} else {
							$fieldsBody[$key]=$fieldsBody[$key]->id;
						}
					} elseif (is_bool($fieldsBody[$key])) {
						$fieldsBody[$key] = $fieldsBody[$key] ? 'Y' : 'N' ; 
					}
					switch ($key){
						case "id":
							$output.="<td class=\"hidden\">".$fieldsBody[$key]."</td>";
							break;
						case "user":
							$output.="<td class=\"hidden\">".$fieldsBody[$key]."</td>";
							break;
						default:
							if(is_numeric($fieldsBody[$key])){
								$output.="<td class=\"td_text\">".Zend_Locale_Format::toNumber($fieldsBody[$key])."</td>";
							} else {
								$output.="<td class=\"td_text\">".$fieldsBody[$key]."</td>";
							}
					}
				}
				$bool = (isset($fieldsBody[$key]));
			}		
		}			
		return $output;
	}
}