<?php	
class ScansController extends Zend_Controller_Action
{	
    public function indexAction()
    {
    	
    	$id = $this->getRequest()->getParam('id');
        $companyId = VSCAN_Sessions::getCurrentCompany();
        $scanForm = new VSCAN_Form_Scan(array('id' => $id));
		if (!empty($id) && !$this->getRequest()->isPost() ) {
			$scan = new VSCAN_Model_Scan();
			$scan = $scan->fetchRow($scan->select()->where('id = ?', $id)->where('company_id = ?', $companyId));
			if ($scan->isMapped()){
                $scanForm->populate($scan->toArray());                
            }else{
                $scanForm->setId(null);   
            }
             
		}

		
        if ($this->getRequest()->isPost()) {
            $formData = $this->getRequest()->getPost();  
            
            if ($scanForm->isValid($formData)) {
                
                try {
                    if (!empty($id)) {
                        //simple creation
                        $values = $scanForm->getValues();
                        if (VSCAN_Company::redirectToHomeUnlessResourceBelongToCompany($values['company'])) return;
	            		VSCAN_Scan::edit($scanForm->getValues());
	            		$this->view->edit = true;
	            	} else {
	            		//extra logic when is creating a scan
	            		VSCAN_Scan::create($scanForm->getValues());
	            		$this->view->new = true;
	            	}
	            	$scanForm = new VSCAN_Form_Scan(array('id' => ''));
            	
            	} catch (Zend_Exception $e) {
            		$elements = $scanForm->getElement('date')->addError($e->getMessage())->markAsError();
            			
            	}
            }
        }
        $this->view->scanForm = $scanForm;
        $scan = new VSCAN_Model_Scan();
        $this->view->scans = $scan->fetchAllForPage(
        	$scan->select()->where('company_id = ?', $companyId)->order('date desc')
        	);
         
		
    }
    public function deleteAction()
    {
    	$id = $this->getRequest()->getParam('id');
		try{
    		$scan =  new VSCAN_Model_Scan();
            $scan->find($id);
            if (!$scan->isMapped()){
                throw new Zend_Exception('Scan not Found');
            }
            if (VSCAN_Company::redirectToHomeUnlessResourceBelongToCompany($scan->getCompany()->getId())) return;
            VSCAN_Scan::delete($id);
		} catch (Zend_Exception $e){
            $this->view->errorMsg = $e->getMessage();
		}
		$this->indexAction();
        $this->render('index');
    }
    
	public function stopAction()
    {
    	$id = $this->getRequest()->getParam('id');
		try{
            $scan =  new VSCAN_Model_Scan();
            $scan->find($id);
            if (VSCAN_Company::redirectToHomeUnlessResourceBelongToCompany($scan->getCompany()->getId())) return;
    		VSCAN_Scan::stop($id);
    		$this->_helper->redirector('index');
		} catch (Zend_Exception $e){
			$this->view->errorMsg = $e->getMessage();
		}
		
    }
}
