<?php
class VSCAN_Form_Company extends VSCAN_Form
{
	
	public function init()
    {
        
       
        $duplicateValidatorCompany = new Zend_Validate_Db_NoRecordExists('companies', 'name');
        if (!empty($this->_id)) {
        	$duplicateValidatorCompany->setExclude(array('field' => 'id', 'value' =>  $this->_id));	
        }
        $duplicateValidatorCompany->setMessage('Company \'%value%\' already exists.');
        
        $this->addElement('text', 'name', array(
            'label'      => 'Name:',
            'required'   => true,
              'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags'),
        		array('filter'=>'Alnum', 'options'=>array('allowwhitespace'))
        	),
            'validators' => array(array('validator' => 'StringLength', 'options' => array(3, 255)))
        ));
        
        
        $this->addElement('text', 'address', array(
            'label'      => 'Description:',
            'required'   => false,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags'),
        		array('filter'=>'Alnum', 'options'=>array('allowwhitespace'))
        	),
            'validators' => array(array('validator' => 'StringLength', 'options' => array(3, 255)))
        ));
        
        $this->addElement('text', 'city', array(
            'label'      => 'City:',
            'required'   => false,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags'),
        		array('filter'=>'Alnum', 'options'=>array('allowwhitespace'))
        	),
            'validators' => array(array('validator' => 'StringLength', 'options' => array(2, 255)))
        ));
        
        $this->addElement('text', 'state', array(
            'label'      => 'State:',
            'required'   => false,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags'),
        		array('filter'=>'Alnum', 'options'=>array('allowwhitespace'))
        	),
            'validators' => array(array('validator' => 'StringLength', 'options' => array(2, 255)))
        ));
        
        $this->addElement('text', 'country', array(
            'label'      => 'Country:',
            'required'   => false,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags'),
        		array('filter'=>'Alnum', 'options'=>array('allowwhitespace'))
        	),
            'validators' => array(array('validator' => 'StringLength', 'options' => array(2, 255)))
        ));
        
         $this->addElement('select', 'timezone', array(
            'ignore'   => false,
         	'required'   => false,
            'label'    => 'Time Zone:',
        	'multiOptions' => VSCAN_Locale::getGMTList()
        ));
        
        $this->addElement('text', 'scans', array(
            'label'      => 'Scans:',
            'required'   => true,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags'),
        	),
				
        	'validators' => array(
        		array('validator' => 'Digits'),
        		array('validator' => 'greaterThan', 'options' => array(-1))
        	)
        ));
        
        $this->addElement('select', 'active', array(
            'ignore'   => false,
            'label'    => 'Status:',
        	'id' => 'active',
        	'multiOptions' => array(0 => 'Inactive', 1 => 'Active'),
        	'value' => 1
        ));
        
        parent::init();
        
    }
}
