<?php

class VSCAN_Form_Scan extends VSCAN_Form
{
	public function init()
    {
    	
    	
        $this->addElement('hidden', 'company', array(
          	'value' => VSCAN_Sessions::getCurrentCompany(), //fisrt company
        ));
        
        $this->addElement('hidden', 'user', array(
          	'value' => VSCAN_Sessions::currentUser()->user->id, //fisrt company
        ));
        
         $this->addElement('hidden', 'status', array(
          	'value' => VSCAN_Scan::READY, //fisrt company
        ));
        
        $this->addElement('text', 'date', array(
            'label'      => 'Date: ',
            'required'   => true,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags')
        	),
            'validators' => array(
            					array('validator' => 'NotEmpty'),
            					array('validator' => new Zend_Validate_Date(array('format'=>Zend_Registry::get('config')->date->format))),
            					array('validator' =>  new VSCAN_Validate_DateAfterNow())
							)
        ));
       parent::init();
        
    }
    public function isValid($data) {
        $result = parent::isValid($data);
        if ($result) {
            $validate = new Zend_Validate_Db_NoRecordExists(array('table' => 'scans', 'field' => 'date'));
                $validate->getSelect()
                    ->where('company_id = ?', $this->getValue('company'));

                if (!empty($this->_id)){
                     $validate->getSelect()->where('id <> ?', $this->_id);
                }
                $this->getElement('date')->addValidator($validate);
             


               
               $date = new Zend_Date();
                    if ($date->isDate($data['date'])) {
                        $date = new Zend_Date($data['date']);
                        $date_db_format = $date->get(Zend_Date::ISO_8601);
                    }
                $result = $validate->isValid($date_db_format);
                $this->getElement('date')->getErrors();
                if (!$result){
                    $this->getElement('date')->addError('The Date already exists.');
                    $this->_errorsExist = true;
                    return;
                }
        }
    	
    	return !$this->isErrors();
    }
}