<?php

class VSCAN_Form_Support extends Zend_Form
{
    protected $_issueValue = 'Technical Support';

    public function setIssue($value){
        $this->_issueValue = $value;
    }

    public function title(){
        return $this->_issueValue;
    }
    
	public function init()
    {
        $this->setMethod('post');
        
        $this->setDisableLoadDefaultDecorators(true);
 
        $this->addDecorator('FormElements')
             ->addDecorator('Form');

        $this->addElement('text', 'company', array(
            'value' => VSCAN_Sessions::getCurrentCompanyName(),
            'disabled' => 'disabled', //fisrt company
            'label'    => 'Group:',
        ));
        
        $this->addElement('text', 'username', array(
            'value' => VSCAN_Sessions::currentUser()->user->fullname,
            'disabled'=>'disabled', //fisrt company
            'label'    => 'User:'
        ));

        $this->addElement('select', 'issue', array(
            'ignore'   => false,
            'required'   => true,
            'label'    => 'Request:',
            'multiOptions' => array(
                'Quote for Additional Scans' => 'Request for Additional Scans',
                //'Quote for Additional Scans' => 'Quote for Additional Scans',
                //'Quote for External/Internal Pentest' => 'Quote for External/Internal Pentest',
                //'Quote for Secure Software Development' => 'Quote for Secure Software Development',
                //'Quote for WebApp Pentest' => 'Quote for WebApp Pentest',
                'Technical Support' => 'Technical Support',
                ),
            'value' => $this->_issueValue
        ));

        $this->addElement('textarea', 'comments', array(
            'ignore'   => false,
            'required'   => false,
            'label'    => 'Comments:',
            'rows'=> '4'
        ));

        $this->addElement('submit', 'submit', array(
            'ignore'   => true,
            'label'    => 'Send',
             'class' =>'btn'
        ));
        
        //Set the decorators we need:
        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            'Errors',
            new Zend_Form_Decorator_HtmlTag(array('tag' => 'div'))
        ));
        
        //Remove label from submit button, and fullname input text:
        $this->submit->removeDecorator('Label');
        
    }
    public function isValid($data) {
    	parent::isValid($data);
    	return !$this->isErrors();
    }
}
