<?php

class VSCAN_Form_Target extends VSCAN_Form
{
	
	public function init()
    {
        
         $this->addElement('hidden', 'company', array(
          	'value' => VSCAN_Sessions::getCurrentCompany(), //fisrt company
        ));
        
         $this->addElement('select', 'type', array(
            'ignore'   => false,
            'label'    => 'Type:',
        	'id' => 'type',
        	'multiOptions' => VSCAN_Target::getTypes()
        ));
        
        $this->addElement('text', 'start', array(
            'label'      => 'Start:',
            'required'   => true,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        	),
        	'validators' => array(array('validator' => 'StringLength', 'options' => array(3,255)))
            //'validators' => array(array('validator' => 'HostName', 'options' => array('allow'=>Zend_Validate_Hostname::ALLOW_IP)))
        ));
          
        $this->addElement('text', 'end', array(
            'label'      => 'End:',
            'required'   => false,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        	)
        ));
        parent::init();
        
    }
    
    public function isValid($data) {
    	$result = parent::isValid($data);
    	
    	if ($result) {
            $validate = new Zend_Validate_Db_NoRecordExists(array('table' => 'targets', 'field' => 'start'));
                $validate->getSelect()
                    ->where('end = ?', $this->getValue('end'))
                    ->where('type = ?', $this->getValue('type'))
                    ->where('company_id = ?', $this->getValue('company'));

                if (!empty($this->_id)){
                     $validate->getSelect()->where('id <> ?', $this->_id);
                }
               
                $this->getElement('start')->addValidator($validate);
                $result = $this->getElement('start')->isValid($data['start']);
                if (!$result){
                    $this->getElement('start')->addError('The Target already exists');
                    $this->_errorsExist = true;
    
                }
        }
	    switch ($this->getElement('type')->getValue()) {
			case VSCAN_Target::HOSTNAME_KEY:
				$this->getElement('start')->addValidator(new VSCAN_Target_Validate_Domain());
				$startValid = $this->getElement('start')->isValid($data['start']);
				$this->_errorsExist = !$startValid;
				break;
			case VSCAN_Target::RANGE_KEY:
				$this->getElement('start')->addValidator(new VSCAN_Target_Validate_Ip());
				
				$startValid = $this->getElement('start')->isValid($data['start']);
				$this->getElement('end')->addValidator(new VSCAN_Target_Validate_Ip());
				$endValid = $this->getElement('end')->isValid($data['end']);
				if (($startValid && $endValid)){
					if (!(ip2long($data['start']) < ip2long($data['end']))) {
						$this->getElement('start')->addError('StartIP must be less than endIP');
						$this->_errorsExist = true;
					}
				}else {
					$this->_errorsExist = true;
				}
				
				break;
			case VSCAN_Target::NETWORK_KEY:
				$this->getElement('start')->addValidator(new VSCAN_Target_Validate_Ip());
				
				$startValid = $this->getElement('start')->isValid($data['start']);
				$this->getElement('end')->addValidator(new VSCAN_Target_Validate_Netmask());
				//$this->getElement('end')->addValidator(new Zend_Validate_Digits());
				$endValid = $this->getElement('end')->isValid($data['end']);
				if (!($startValid && $endValid)){
					$this->_errorsExist = true;
					
				}
				break;
			default:
				//die('noooo');
				return false;
		}
		
    	return !$this->isErrors();
    }
}