<?php 

class VSCAN_Form_UserLogin extends VSCAN_Form
{	
	public function init()
    {
        $this->setMethod('post');

        $this->setDisableLoadDefaultDecorators(true);
 
        $this->addDecorator('FormElements')
             ->addDecorator('Form');
             
        $this->addElement('hidden', 'idForm', array(
        		'value' => 'userLogin'
        	)
        );
        
        $this->addElement('text', 'username', array(
            'label'      => 'Username:',
            'required'   => true,
            'class' => 'input-large',
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags')
        	),
            'validators' => array(
        		array('validator' => 'StringLength', 'options' => array(3, 255)))
        ));
        
        $this->addElement('password', 'password', array(
            'label'      => 'Password:',
            'required'   => true,
            'class' => 'input-large',
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags')
        	)
        ));
        
        $this->addElement('submit', 'submit', array(
            'ignore'   => true,
            'label'    => 'Login',
        	'id' => 'login',
            'class' =>'btn'
        ));
        
        //Set the decorators we need:
        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            array('Errors', array('class' => 'errors')),
            //'Errors',
            new Zend_Form_Decorator_HtmlTag(array('tag' => 'div')) //wrap elements in <div>'s
        ));
        
        //Remove label from submit button:
        $this->submit->removeDecorator('Label');
        
    }
}