<?php

class VSCAN_Form_UserRegistration extends VSCAN_Form
{

	
	public function init()
    {
        
        $this->addElement('hidden', 'idForm', array(
        		'value' => 'userRegister'
        	)
        );
        
        $this->addElement('text', 'fullname', array(
            'label'      => 'Full Name:',
            'required'   => false,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags'),
        		array('filter'=>'Alnum', 'options'=>array('allowwhitespace'))
        	),
            'validators' => array(array('validator' => 'StringLength', 'options' => array(3, 255)))
        ));
        
        $duplicateValidatorEmail = new Zend_Validate_Db_NoRecordExists('users', 'email');
        if (!empty($this->_id)) {
        	$duplicateValidatorEmail->setExclude(array('field' => 'id', 'value' =>  $this->_id));	
        }
        $duplicateValidatorEmail->setMessage('Email \'%value%\' already exists.');
        
        $this->addElement('text', 'email', array(
            'label'      => 'E-mail:',
            'required'   => true,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags'),
        		array('filter'=>'StringToLower')
        	),
            'validators' => array(
        		array('validator' => 'EmailAddress'),
        		array('duplicateFileName' => $duplicateValidatorEmail)
        	)
        ));
        
        $duplicateValidatorUserName = new Zend_Validate_Db_NoRecordExists('users', 'username');
        if (!empty($this->_id)) {
        	$duplicateValidatorUserName->setExclude(array('field' => 'id', 'value' =>  $this->_id));	
        }
        $duplicateValidatorUserName->setMessage('Username \'%value%\' already exists.');
        
        $this->addElement('text', 'username', array(
            'label'      => 'Username:',
            'required'   => true,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags')
        	),
            'validators' => array(
        		array('validator' => 'StringLength', 'options' => array(3, 255)),
        		array('filter'=>'Alnum'),
        		array('duplicateUserName' => $duplicateValidatorUserName)        		
        	)
        ));
        
        $passwordRequired = empty($this->_id);
       
        $this->addElement('password', 'password', array(
            'label'      => 'Password:',
            'required'   => $passwordRequired,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags')
        	),
            'validators' => array(array('validator' => 'StringLength', 'options' => array(5, 255)))
        ));
        
        $this->addElement('password', 'verifypassword', array(
            'label'      => 'Verify Password:',
            'required'   => $passwordRequired,
            'filters'    => array(
        		array('filter'=>'StringTrim'),
        		array('filter'=>'StripTags')
        	),
            'validators' => array(
        		array(
        		'validator' => 'Identical', 
        		'options' => array('token' => 'password')
        		)
        		
        	)
        ));
        
        $role = new VSCAN_Model_Role();
        $roles = $role->fetchAll();
        foreach ($roles as $role) {
        	$roleMultiOptions[$role->getId()] = $role->getName();
        }
     	$role_id = 2; // role by default
        if (!empty($this->_id)) {
     		$roles = VSCAN_User::getRolesByUserId($this->_id);
     		if (empty($roles[0])) {
     			throw new Zend_Exception("user don't have any role");
     		}
     		$role_id = $roles[0]->getId();
        }
        $this->addElement('select', 'role', array(
            'ignore'   => false,
            'label'    => 'Role:',
        	'id' => 'role',
        	'multiOptions' => $roleMultiOptions,
        	'value' => $role_id //simple role
        ));
        
        $company = new VSCAN_Model_Company();
        $companies = $company->fetchAll();
        foreach ($companies as $company) {
        	$companyMultiOptions[$company->getId()] = $company->getName();
        }
    	$company_id = 1; // Company by default
        if (!empty($this->_id)) {
     		$companies = VSCAN_User::getCompaniesByUserId($this->_id);
     		if (empty($companies[0])) {
     			throw new Zend_Exception("user don't have any Company");
     		}
     		$company_id = $companies[0]->getId();
        }
        $this->addElement('select', 'company', array(
            'ignore'   => false,
            'label'    => 'Group:',
        	'id' => 'company',
        	'multiOptions' => $companyMultiOptions,
        	'value' => $company_id, //fisrt company
        ));
        
        $this->addElement('select', 'active', array(
            'ignore'   => false,
            'label'    => 'Status:',
        	'id' => 'active',
        	'multiOptions' => array(0 => 'Inactive', 1 => 'Active'),
        	'value' => 1
        ));
        parent::init();
    }
}
