<?php
/**
 * 
 * 
 *
 */
class VSCAN_Model_Scan extends VSCAN_Model_Abstract
{
	protected $_company;	
	protected $_user;
	protected $_date;
	protected $_status;
	protected $_uuid;
	protected $_targets;
	protected $_created;
	
	
	public function getUser()
	{
		return $this->_user;	
	}
	
	public function setUser($value)
	{
		$this->_convertToModel('VSCAN_Model_User', $value);
		$this->_user = $value;	
	}
	
	public function getDate($format=null)
	{
		$date = new Zend_Date();
		if(!empty($this->_date)) {
			if (!$date->isDate($this->_date)) {
				$date->set($this->_date, Zend_Date::ISO_8601);
			}else{
				$date->set($this->_date);
			}

        	if (is_null($format)) {
        		$format = Zend_Registry::get('config')->date->format;
        	}
        	$this->_date = $date->toString($format, null, 'en');
		}
		return $this->_date;	
	}
	
	public function setDate($value)
	{
		$this->_date = $value;	
	}
	
	public function getStatus()
	{
		return $this->_status;	
	}
	
	public function setStatus($value)
	{
		$this->_status = $value;	
	}
	
	public function getCompany()
	{
		return $this->_company;	
	}
	
	public function setCompany($value)
	{
		$this->_convertToModel('VSCAN_Model_Company', $value);
		$this->_company = $value;	
	}
	public function getUuid()
	{
		return $this->_uuid;	
	}
	
	public function setUuid($value)
	{
		$this->_uuid = $value;	
	}
	public function setTargets($value){
		$this->_targets = $value;	
	}
	public function getTargets(){
		return $this->_targets;
	}
	public function getCreated()
	{
		return $this->_created;
	}
	
	public function setCreated($value)
	{
		$this->_created = $value;
	}
	public function getModified()
	{
		$date = new Zend_Date();
		if(!empty($this->_modified)) {
			$date->set($this->_modified, Zend_Date::ISO_8601);
        	$this->_modified = $date->toString(Zend_Registry::get('config')->date->format, null, 'en');
		}
		return $this->_modified;

	}
	
	public function toArray()
	{
		return array (
			'id' => $this->getId(),
			'user' => $this->getUser(),
			'date' => $this->getDate(),
			'status' => $this->getStatus(),
			'company' => $this->getCompany(),
			'uuid' => $this->getUuid(),
			'targets' => $this->getTargets(),
			'created' => $this->getCreated()
		);
	}
	
	public function getMapper()
    {
        if (null === $this->_mapper) {
            $this->setMapper('VSCAN_Model_Mapper_Scan');
        }
        return $this->_mapper;
    }
    
}