<?php
/**
 * 
 * This model is controlled by the VSCAN_User class
 *
 */
class VSCAN_Model_User extends VSCAN_Model_Abstract
{
	protected $_id;
	protected $_fullname;
	protected $_email;
	protected $_username;
	protected $_password;
	protected $_active;
	protected $_created;
	
	protected $_isPasswordChanged = false;
	
	public function getFullname()
	{
		return $this->_fullname;	
	}
	
	public function setFullname($value)
	{
		$this->_fullname = $value;	
	}
	
	public function getEmail()
	{
		return $this->_email;
	}
	
	public function setEmail($value)
	{
		$this->_email = $value;
	}
	
	public function getUsername()
	{
		return $this->_username;
	}
	
	public function setUsername($value)
	{
		$this->_username = $value;
	}
	
	public function getPassword()
	{
		return $this->_password;
	}
 	
	public function setActive($active)
    {
        $this->_active = (boolean) $active;
        return $this;
    }
 
    public function getActive()
    {
        return (boolean)$this->_active;
    }
	
    
	/** 
	 * used by mapper
	 * @param string $value MD5
	 */
	public function setPassword($value)
	{
		$this->_password = $value;
	}
	/**
	 *Set new password to the user
	 * @param string $value plain
	 */
	public function setNewPassword($value)
	{
		$this->_password = $value;
		$this->_isPasswordChanged = true;
	}
	
	public function getCreated()
	{
		return $this->_created;
	}
	
	public function setCreated($value)
	{
		$this->_created = $value;
	}
	
	public function toArray()
	{
		return array (
			'id' => $this->getId(),
			'fullname' => $this->getFullname(),
			'email' => $this->getEmail(),
			'username' => $this->getUsername(),
			'active' => $this->getActive(),
			'password' => $this->getPassword(),
			'created' => $this->getCreated()
		);
	}
	
	public function getMapper()
    {
        if (null === $this->_mapper) {
            $this->setMapper('VSCAN_Model_Mapper_User');
        }
        return $this->_mapper;
    }
    
    public function save($primaryKey = 'id')
    {

    	$id = $this->getId();
    	if ($this->_isPasswordChanged 
    		|| empty($id)
    	) {
    		$salt = Zend_Registry::get('config')->encrypt->salt;
    		$this->_password = md5($salt.$this->_password);
    	}
    	
		return parent::save();
    }
}