<?php
class VSCAN_Plugin_Auth extends Zend_Controller_Plugin_Abstract
{
	/**
	 * (non-PHPdoc)
	 * @see Zend_Controller_Plugin_Abstract::preDispatch()
	 */
	public function preDispatch(Zend_Controller_Request_Abstract $request)
	{
		$indexActions = array ('index');
		$auth = null;
		$gotoUrl = '/';
		$moduleName = $this->getRequest()->getModuleName();
		
		$auth = VSCAN_Sessions::currentUser();
		
		$redirector = new Zend_Controller_Action_Helper_Redirector();
        $redirector->setExit(false);
		if (
			($request->getControllerName() != 'index' || !in_array($request->getActionName(), $indexActions)
			|| 'admin' == $moduleName)
		&& !$auth->logged
		) {
                $redirector->gotoUrl($gotoUrl);
		}
		//Admin access control before each dispatch
		if ($auth->logged) {
			//set current Company
			VSCAN_Sessions::setCurrentCompany($this->getRequest()->getParam('current_company', -1));
			
			$acl = new VSCAN_Acl($auth->user);
			if (!$acl->isUserAllowed('administration') && 'admin' == $moduleName) {
				$redirector->gotoUrl($gotoUrl);
			}
			//navigation
			if ($acl->isUserAllowed('administration')) {
            	
				$view = Zend_Controller_Front::getInstance()->getParam('bootstrap')->getResource('view');
				$view->navigation()->findOneBy('id', 'admin')->setVisible(true);
			}
		}
		
		
		
	}
}