<?php
class Zend_View_Helper_DetailsReport extends Zend_View_Helper_Abstract
{	
	public $_reportItems = array();
	protected $_details = array();
	protected $_name = '';
	protected $_userAllowedPluginID = false;
	protected $_showSolved = true;

	public function detailsReport($reportId = null, $showSolved = true){
		$this->_showSolved = (bool)$showSolved;
		if (empty($reportId)) return $this;
 		$this->_reportItems = VSCAN_Report::getDetailsReport($reportId, VSCAN_Sessions::getCurrentCompany(), $this->_name);
		return $this;
	}
	public function hasOne(){
		return !empty($this->_reportItems);
	}
	public function getName(){
		return $this->_name;
	}
	public function getDetails($reportItemId = null) {
		
		//check pluginID resource
		
		//do no remove the following lines
		$acl = new VSCAN_Acl(VSCAN_Sessions::currentUser()->user);		
		//$this->_userAllowedPluginID = true;//$acl->isUserAllowed('pluginID');
		$this->_userAllowedPluginID = $acl->isUserAllowed('pluginID');

		if (empty($reportItemId)) {
			foreach ($this->_reportItems as $reportItem) {
				$row = $this->getDetail($reportItem);
				if (!($row['status'] == VSCAN_Scan::SOLVED && !$this->_showSolved)) {
					$this->_details[] = $row;
				}
			}
		
		} else {

			$reportItem =  new VSCAN_Model_ReportItem();
			$reportItem->find($reportItemId);
			$row = $this->getDetail($reportItem);
			if (!($row['status'] == VSCAN_Scan::SOLVED && !$this->_showSolved)){
				$this->_details[] = $row;
			}
		}
		return $this->_details;	
	}
	
	private function convertToKeyValue($data){
		$data = get_object_vars($data);
		$output = array();
		foreach ($data as $key=>$value) {
			//TODO: refactor to replace all stuff
			if (in_array($key, VSCAN_Report::$HIDDEN_FIELDS_DATA)) {
				continue;
			}
			if ( $key == 'plugin_output' ){
				$key = 'output';
			}			
			$output[$key]['key'] = $key;
			$output[$key]['value'] = $value;
		}
		return $output;
	}
	private function getDetail($reportItem){
		$row = array();
		$data = json_decode($reportItem->getData());
		$attributes = json_decode($reportItem->getAttributes());
		if ($attributes->port == 0) {
			$attributes->port = 'general';	
		}
		$row['service'] = $attributes->port . "/" . $attributes->protocol;
		if (isset($data->risk_factor)){
			$row['risk_factor'] = ($data->risk_factor == 'None')?'Info':$data->risk_factor;
			unset($data->risk_factor); 
		}
		if($this->_userAllowedPluginID) {
			$row['pluginID'] = $attributes->pluginID;
		}
		$row['pluginName'] = $attributes->pluginName;
		$row['data'] = $this->convertToKeyValue($data);
		$row['id'] = $reportItem->getId();
		$row['status'] = $reportItem->getStatus();
		return $row;
	}
}