<?php
class Zend_View_Helper_LastReport extends Zend_View_Helper_Abstract
{	
	public $_reports;
	public $_scanId;
	protected $_reportItems = array();
	protected $_targets = array();
	public function lastReport($scan = null){
		$this->_reports = null;
		$this->_reportItems = array();
		$this->_targets = array();

 		if ($scan === null) {
			$this->_reports = VSCAN_Report::getLastReport(VSCAN_Sessions::getCurrentCompany(), $this->_scanId);
	 		
 		}else {
 			$this->_scanId = $scan->getId();
 			$this->_reports = VSCAN_Report::getReportsByScan($scan->getId());
 		}

		if (!empty($this->_reports)) {
 			foreach ($this->_reports as $report) {
 					$reportItems = new VSCAN_Model_ReportItem();
 					$reportItems = $reportItems->fetchAll($reportItems->select()->where('report_id = ?', $report->getId()));
 					$this->_reportItems[$report->getId()] = $reportItems;
 					$this->_targets[$report->getId()]['name'] = $report->getName();
 			}
	    		
	 	}
		return $this;
	}


	public function hasOne(){
		return !empty($this->_reports);
	}	
	public function getTargets()
    {
    	
    	if (empty($this->_reports)) {
    		return null;
    	}
  
	    foreach ($this->_reportItems as $reportId => $reportItems) {
 			$chartValues = array('Critical'=> 0,
		    	'High'=> 0,
		    	'Medium'=> 0,
		    	'Low'=> 0,
		    	'None'=> 0,
		    	'Solved'=> 0,
          'Omitted'=>0
	    	);
 			$services = array();
 			foreach ($reportItems as $reportItem){
	 			$data = json_decode($reportItem->getData());
	 			$attributes = json_decode($reportItem->getAttributes());
	 			if ($attributes->port == 0) {
	 				$attributes->port = 'general';	
	 			}
	 			$service = $attributes->port . "/" . $attributes->protocol;
	 			if (!in_array($service, $services)) {
	 				$services[$attributes->port] = $service;
	 			}
	 			if (isset($data->risk_factor)){
		 			if (!isset($chartValues[$data->risk_factor])) {
		 				$chartValues[$data->risk_factor] = 0;
		 			}
		 			if ($reportItem->getStatus() == VSCAN_Scan::SOLVED) {
		 				$chartValues['Solved'] += 1;
		 			} elseif ($reportItem->getStatus() == VSCAN_Scan::OMITTED) {
            $chartValues['Omitted'] += 1;
          } else {
		 				$chartValues[$data->risk_factor] += 1;
		 			}
		 			
	 			}

 			}
 			$name = $this->_targets[$reportId]['name'];
 			$this->_targets[$reportId] = $chartValues;
 			ksort($services);
 			$this->_targets[$reportId]['services'] = implode(', ',$services);
 			$this->_targets[$reportId]['vulnerabilities'] = count($reportItems);
 			$this->_targets[$reportId]['name'] = $name;
 			$this->_targets[$reportId]['id'] = $reportId;
 		}
 		
 		return $this->_targets;
 		
    }
    
    public function getChartValues() {
    	
    	if (empty($this->_reports)) {
    		return null;
    	}
    		
 		$chartValues = array('Critical'=> 0,
	    	'High'=> 0,
	    	'Medium'=> 0,
	    	'Low'=> 0,
	    	'None'=> 0,
	    	'Solved'=> 0,
        'Omitted' => 0
	    );
 		foreach ($this->_reportItems as $reportItems) {
 			foreach ($reportItems as $reportItem){
	 			$data_json = $reportItem->getData();
	 			$data = json_decode($data_json);
	 			if (isset($data->risk_factor) && $data->risk_factor != 'None' ){
		 			if (!isset($chartValues[$data->risk_factor])) {
		 				$chartValues[$data->risk_factor] = 0;
		 			}
		 			if ($reportItem->getStatus() == VSCAN_Scan::SOLVED){
		 				$chartValues['Solved'] += 1;
		      } elseif ($reportItem->getStatus() == VSCAN_Scan::OMITTED){
            $chartValues['Omitted'] += 1;
          } else {
		 				$chartValues[$data->risk_factor] += 1;
		 			}
		 			
	 			}
 			}
 			
 		}
    	
    	$chart['values'] = $chartValues;
    	return $chart;
    	
    }
}