<?php
class Zend_View_Helper_Reports extends Zend_View_Helper_Abstract
{	
	protected $_reports = array();
	
	protected $_columns = array (
		'Critical' => 0,
		'High' => 0,
		'Medium' => 0,
		'Low' => 0,
		'None' => 0,
		'Solved'=> 0,
		'Omitted' => 0,
		'vulnerabilities' => 0,
		'targets' => '',
		'id' => null
    );
    
	public function reports($scans){
 		
 		foreach ($scans as $k=>$scan) {
 			$scanId = $scan->getId();
 			//nullify the metadata cache to avoid problems
 			Zend_Db_Table_Abstract::setDefaultMetadataCache(null);
 			if (!(Zend_Registry::get(VSCAN_Cache::CACHE_NAME)->test(VSCAN_Cache::PF_REPORTS.$scanId))) {
	 			$reports = $this->view->LastReport($scan)->getTargets();
	 			
	 			if (is_array($reports)){
	 				$repo = $this->_columns;
		 			foreach ($reports as $report) {
		 				$repo['Solved']+=$report['Solved'];
		 				$repo['Omitted']+=$report['Omitted'];
		 				$repo['Critical']+=$report['Critical'];
		 				$repo['High']+=$report['High'];
		 				$repo['Medium']+=$report['Medium'];
		 				$repo['Low']+=$report['Low'];
		 				$repo['None']+=$report['None'];
		 				$repo['vulnerabilities']+=$report['vulnerabilities'];
		 				$repo['targets'].= empty($repo['targets'])?$report['name']: ', ' . $report['name'];
		 			}
		 			$repo['id'] = $scan->getId();
		 			$repo['date']= $scan->getDate();
	 			}
	 			Zend_Registry::get(VSCAN_Cache::CACHE_NAME)->save($repo, VSCAN_Cache::PF_REPORTS.$scanId, array(VSCAN_Cache::PF_REPORTS.$scanId));
 			}else{
 				$repo = Zend_Registry::get(VSCAN_Cache::CACHE_NAME)->load(VSCAN_Cache::PF_REPORTS.$scanId);
 			}
 			Zend_Db_Table_Abstract::setDefaultMetadataCache(VSCAN_Cache::CACHE_NAME);
 			$this->_reports[$k] = $repo;
 		}
		return $this->_reports;
	}
}