<?php
class VSCAN_Acl extends Zend_Acl
{
 	const ADMIN_ROLE = 'admin';
 	/**
 	 * 
 	 * Roles of a user
 	 * @var array
 	 */
    protected $_usersRoles = array();
 	/**
 	 * 
 	 * VSCAN_Model_User
 	 * @var VSCAN_Model_User $_user
 	 */
    protected $_user = null;
 
    
    public function __construct(VSCAN_Model_User $user)
    {
    		$this->_user = $user;
    		$this->_initAllResources();
        	$this->_initRoleResourceByUser();
    }
 
    private function _initAllResources()
    {
    	$resources = new VSCAN_Model_Resource();
    	$resources = $resources->fetchAll();
    	foreach ($resources as $resource) {
    		$this->addResource($resource->getName());
    	}
    }
 
    private function _initRoleResourceByUser()
    {
 		$rolesUser = new VSCAN_Model_RoleUser();
 		$rolesUser = $rolesUser->fetchAll(
 			$rolesUser->select()
 				->where('user_id = ?', $this->_user->getId())
 		);
       
        foreach ($rolesUser as $roleUser) {
        	$roleName = $roleUser->getRole()->getName();
        	$this->_usersRoles[] = $roleName;
        	$this->addRole($roleName);
        	
        	$roleId =  $roleUser->getRole()->getId();
        	$roleResources = new VSCAN_Model_RoleResource();
        	$roleResources = $roleResources->fetchAll(
        		$roleResources->select()
 					->where('role_id = ?', $roleId)
        	);
        	
        	foreach ($roleResources as $roleResource) {
        		$resourceName = $roleResource->getResource()->getName();
            	$this->allow($roleName, $resourceName, 'access');
        	}
        }
    }
 
    public function listRoles()
    {
       //@TODO
    }
 
    public function getRoleId($roleName)
    {
       //@TODO
    }
 
    public function listResources()
    {
        //@TODO
    }
 
    public function isUserAllowed($resource, $permission='access')
    {
    	$isAllowed = false;
    	foreach ($this->_usersRoles as $role) {
    	
        	if ($this->isAllowed($role, $resource, $permission)) {
	         	$isAllowed = true;
	         	break;
        	}
    	}
    	return $isAllowed;
    }
	
}