<?php
class VSCAN_Authenticator 
{
 	protected static $_instance = null;
	
	/**
	 *  Result of the authentification
	 * @var Zend_Auth_Result
	 */
 	protected $_authResult;
 	
 	/**
     * Singleton pattern implementation makes "new" unavailable
     *
     * @return void
     */
    protected function __construct()
    {}

    /**
     * Singleton pattern implementation makes "clone" unavailable
     *
     * @return void
     */
    protected function __clone()
    {}

    /**
     * Returns an instance of BJBPO_Authenticator
     *
     * Singleton pattern implementation
     *
     * @return VSCAN_Authenticator Provides a fluent interface
     */
    public static function getInstance()
    {
        if (null === self::$_instance) {
            self::$_instance = new self();
        }

        return self::$_instance;
    }
    
    /**
     * 
     * Basic Authentification 
     * @param string $username
     * @param string $password
     * @return Zend_Auth_Result
     */
	public function authenticate($username, $password)
	{
     	$zendAuth = Zend_Auth::getInstance();
    	$dbAdapter = Zend_Db_Table_Abstract::getDefaultAdapter();
 
		$authAdapter = new Zend_Auth_Adapter_DbTable($dbAdapter);
		$config = Zend_Registry::getInstance()->get('config');
        $salt = Zend_Registry::get('config')->encrypt->salt;
		$authAdapter
		    ->setTableName($config->auth->table)
		    ->setIdentityColumn($config->auth->user)
		    ->setCredentialColumn($config->auth->password)
		    ->setIdentity($username)
		    ->setCredential($salt.$password)
		    ->setCredentialTreatment('MD5(?) and active = 1');
		
		$this->_authResult = $zendAuth->authenticate($authAdapter);
		return $this->_authResult;
	}

		
}