<?php

class VSCAN_Form extends Zend_Form {
	
	protected $_id;

	public function setId($id = '')
	{
	    $this->_id = $id; 
	    $this->init();   
	}
	//depending of updateing or adding a new one
	public function title() {
		return (empty($this->_id))?'Add':'Update';
	}

	public function init()
    {
    	$this->setMethod('post');
        
        $this->setDisableLoadDefaultDecorators(true);
 
        $this->addDecorator('FormElements')
             ->addDecorator('Form');
        
        $this->addElement('hidden', 'id', array(
        	'value'=>null
        ));


        $this->addElement('submit', 'submit', array(
            'ignore'   => true,
            'label'    => (empty($this->_id))?'Add':'Update',
             'class' =>'btn'
        ));
        
        //Set the decorators we need:
        $this->setElementDecorators(array(
            'ViewHelper',
            'Label',
            'Errors',
            new Zend_Form_Decorator_HtmlTag(array('tag' => 'div'))
        ));
        
        //Remove label from submit button, and fullname input text:
        $this->submit->removeDecorator('Label');
    }
	
	/**
	 * Process populate data to find object and get the ID values
	 * (non-PHPdoc)
	 * @see Zend_Form::populate()
	 */
	public function populate($values){
		$valuesPlain = array();
		foreach ($values as $key=>$value) {
			if (is_object($value) && method_exists($value, 'getId')) {
				$valuesPlain[$key] = $value->getId();
			}else {
				$valuesPlain[$key] = $value;
			}
		}
		
		return parent::populate($valuesPlain);
	}
	
}