<?php

class VSCAN_Mail {
	
    const SCAN_FINISHED_TEMPLATE = '<p>The scan scheluded for <b>%date%</b> by the user <b>%user_fullname%</b> has finished.</p>
    <p>Message sent from VSCAN.</p>';
	const SUPPORT_TEMPLATE = '
                        <html>
                        <body>
                          <h2>Request: %request% </h2>
                          <table style=" font-family: verdana,arial,sans-serif;
                                font-size:11px;
                                color:#333333;
                                border-width: 1px;
                                border-color: #666666;
                                border-collapse: collapse;">
                            <tr>
                              <th style="border-width: 1px;
                                padding: 8px;
                                border-style: solid;
                                border-color: #666666;
                                background-color: #dedede;">User</th><th style="border-width: 1px;
                                padding: 8px;
                                border-style: solid;
                                border-color: #666666;
                                background-color: #dedede;">Email</th><th style="border-width: 1px;
                                padding: 8px;
                                border-style: solid;
                                border-color: #666666;
                                background-color: #dedede;">Company</th>
                            </tr>
                            <tr>
                              <td style="border-width: 1px;
                                padding: 8px;
                                border-style: solid;
                                border-color: #666666;
                                background-color: #ffffff;"><a href="%link_to_user%">%user_fullname%</a></td>
                              <td style="border-width: 1px;
                                padding: 8px;
                                border-style: solid;
                                border-color: #666666;
                                background-color: #ffffff;">%user_email%</td>
                              <td style="border-width: 1px;
                                padding: 8px;
                                border-style: solid;
                                border-color: #666666;
                                background-color: #ffffff;"><a href="%link_to_company%">%company_name%</a></td>
                            </tr>
                            <tr>
                                <td colspan="3" style="border-width: 1px;
                                padding: 8px;
                                border-style: solid;
                                border-color: #666666;
                                background-color: #ffffff;"><strong>%comments%</strong></td>
                            </tr>
                          </table>
                          <p>Message sent from %host%</p>
                        </body>
                        </html>
                        ';
    const SCAN_FINISHED_TEMPLATE_FOR_USERS = '<body style="background-color: silver; color: rgb(0, 0, 0);" alink="#ee0000" link="#0000ee" vlink="#551a8b">

            <table style="text-align: left; width: 100px; margin-left: auto; margin-right: auto; background-color: white;" border="0" cellpadding="4" cellspacing="2">

              <tbody>
                <tr>
                  <td colspan="5" rowspan="1" style="vertical-align: middle; text-align: center;"><a href="%vscan_url_home%" target="_blank"><img style="width: 576px; height: 150px;" alt="" src="%vscan_url_home%img/template_email/header.png"><br>
                  </a></td>
                </tr>
                <tr>
                  <td style="vertical-align: top;"><br>
                  </td>
                  <td style="vertical-align: top; font-family: Arial,Tahoma; font-size: 12px;"><br>
                  Dear %user_fullname%, we would like to announce you that there is a new <span style="font-weight: bold;">Vulnerability Assessment </span>report available for your group.<br>
                  <br>
                  Your review of this report is very important in order to evaluate and to take the required corrective actions.<br>
                  <br>
                  To access our web-based platform, please click <a href="%vscan_url_report%" target="_blank">here</a>.<br>
                  <br>
                  Please do not hesitate to contact us for any additional information.<br>
                  <br>
                  Best regards,<br>
                  <br>
                  VScan Team.<br>
                  <br>
                  </td>
                  <td style="vertical-align: top;"><br>
                  </td>
                  <td style="vertical-align: middle; text-align: center;"><a href="%vscan_url_home%" target="_blank"><img style="border: 0px solid ; width: 207px; height: 74px;" alt="" src="%vscan_url_home%img/template_email/logovscan.png"></a><br>
                  </td>
                  <td style="vertical-align: top;"><br>
                  </td>
                </tr>
                <tr>
                  <td colspan="5" rowspan="1" style="vertical-align: middle; background-color: rgb(51, 52, 52); text-align: right;"><a href="http://www.vanguardsec.com" target="_blank"><img style="width: 130px; height: 22px;" alt="" src="%vscan_url_home%img/template_email/logo.jpg"><br>
                  </a></td>
                </tr>
              </tbody>
            </table>

            </body>';

	protected $_currentTemplate;
	protected $_values;
	protected $_to;
	protected $_subject;


	function __construct(array $values, $subject, $to=null, $template=null){
		
		if ($to == null){
			$to = Zend_Registry::get('config')->admin->email;
		}
		if ($template == null){
			$this->_currentTemplate = self::SUPPORT_TEMPLATE;
		}else{
            $this->_currentTemplate = $template;
        }

		$this->_values = $values;
		$this->_to = $to;
		$this->_subject = $subject;
	}

	public function send() {
		$headers  = 'MIME-Version: 1.0' . "\r\n";
        $headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		$content = $this->fillTemplate($this->_values, $this->_currentTemplate);
		return mail($this->_to, $this->_subject, $content, $headers);
	}

	protected function fillTemplate(array $values, $template){

		foreach ($values as $key=>$value){
			$template = str_replace("%$key%", $value, $template);
		}
		return $template;
	}
}
