<?php
/**
 * Wrapper of Zend_Session to include operations related with VSCAN
 * Common used on login and logout
 *
 */
class VSCAN_Sessions
{
	const KEY_USER_AUTH = 'Zend_Auth';
	/**
	 * Store the user on the session
	 * @param string $userName
	 */
	public static function create($userName) {
		$auth = new Zend_Session_Namespace(self::KEY_USER_AUTH);
		$auth->logged = true;
		$user = new VSCAN_Model_User();
		$user->fetchRow($user->select()->where(' username = ? ', $userName));
		$auth->user = $user;
		$auth->username = $user->getUsername();
		return $auth;
	}
	
	public static function destroy() {
		Zend_Session::destroy();
	}
	/**
	 * 
	 * The current session for the current user 
	 * @return Zend_Session_Namespace
	 */
	public static function currentUser(){
		return new Zend_Session_Namespace(self::KEY_USER_AUTH);
	}
	/**
	 * wrapper to direct access of the currentcomany ID
	 * @return int ID
	 */
	public static function getCurrentCompany() {
		return self::currentUser()->current_company;
	}

	/**
	 * wrapper to direct access of the currentcomany NAME
	 * @return int ID
	 */
	public static function getCurrentCompanyName() {
		$company = new VSCAN_Model_Company();
		$company->find(self::currentUser()->current_company);
		return $company->getName();		
	}
	
	/**
	 * 
	 * Set the current company
	 * @param session $auth
	 * @param int $companyId    
	 */
	public static function setCurrentCompany($companyId) {
		$auth = self::currentUser();
		if ($companyId != -1 && VSCAN_User::hasCompany($auth->user, $companyId)) {
			$auth->current_company = $companyId;
			
		} elseif (!isset($auth->current_company)) {
			$companies = VSCAN_Company::getAllCompaniesNameByUser($auth->user);
			$auth->current_company = key($companies);
		}	
	}
	/**
	 * 
	 * Set the show solved 
	 * @param int $value
	 */
	public static function setShowSolved($value) {
		$auth = self::currentUser();
		$auth->show_solved = $value;
	}

	/**
	 * 
	 * Set the show solved
	 */
	public static function getShowSolved() {
		$auth = self::currentUser();
		return ($auth->show_solved==null)?true:$auth->show_solved;
	}


}