<?php

class VSCAN_Target_Validate_Domain extends Zend_Validate_Abstract {
	
	const INVALID      = 'domainInvalid';
    
	protected $_messageTemplates = array(
        self::INVALID      => "'%value%' is not a valid Domain/IP"
    );
	
	public function isValid($value)
	{
		$this->_setValue($value);
		$validIp = new VSCAN_Target_Validate_Ip();
		$retorno = $validIp->isValid($value);
		if(!$retorno) {
			$dnsr = @dns_get_record("$value", DNS_A);
			if (empty($dnsr)) {
				$retorno = false;
			}else {
				$ipr = $dnsr[0]['ip'];
				if($ipr) {
					$retorno = $validIp->isValid($ipr);// El dominio existe y es valido
				}
			}
		}
	    if (!$retorno) {
	    	$this->_error(self::INVALID);
	    	return false;
	    }
		return $retorno;
	}

}