<?php

class VSCAN_Target_Validate_Ip extends Zend_Validate_Abstract {
	
	const INVALID      = 'ipInvalid';
	const PRIVATE_IP      = 'ipPrivate';
	const LOCAL_IP      = 'ipLocal';
    const BLOCK_LAN = true;
	
    protected $_options = array();
	protected $_messageTemplates = array(
        self::INVALID      => "'%value%' is not a valid IP",
        self::PRIVATE_IP      => "'%value%' seems to be a private IP",
        self::LOCAL_IP		=> "'%value%' seems to be a local IP",
    );
	
    
	public function isValid($value)
	{
		$this->_setValue($value);
		if(filter_var($value, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) {
			try {
				$blockLan = Zend_Registry::get('config')->ip->blockLan;
			}catch (Exception $e){
				throw new Exception('blockLan key does not exist');
			}
	
			if($blockLan) {
				
				if(filter_var($value, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE)){
					if($value == "127.0.0.1") {
						$this->_error(self::LOCAL_IP);
						return false; // La IP es localhost
					}
					return true;
				}
				$this->_error(self::PRIVATE_IP);
				return false; // La IP es privada
			}
	    	return true; // SI es una IP o un Dominio valido
		}
		$this->_error(self::INVALID);
		return false; // NO es una IP ni un Dominio valido
	}

}