<?php

class VSCAN_Target_Validate_Netmask extends Zend_Validate_Abstract {
	
	const INVALID      = 'NetmaskInvalid';
    const MIN_MASK		= 24;
    const MAX_MASK		= 32;
	protected $_messageTemplates = array(
        self::INVALID      => "'%value%' is not a valid Netmask"
    );
	
    
    protected $_netmasks = array(
    		1 => "128.0.0.0",
	        2 => "192.0.0.0",
	        3 => "224.0.0.0",
	        4 => "240.0.0.0",
	        5 => "248.0.0.0",
	        6 => "252.0.0.0",
	        7 => "254.0.0.0",
	        8 => "255.0.0.0",
	        9 => "255.128.0.0",
	        10 => "255.192.0.0",
	        11 => "255.224.0.0",
	        12 => "255.240.0.0",
	        13 => "255.248.0.0",
	        14 => "255.252.0.0",
	        15 => "255.254.0.0",
	        16 => "255.255.0.0",
	        17 => "255.255.128.0",
	        18 => "255.255.192.0",
	        19 => "255.255.224.0",
	        20 => "255.255.240.0",
	        21 => "255.255.248.0",
	        22 => "255.255.252.0",
	        23 => "255.255.254.0",
	        24 => "255.255.255.0",
			25 => "255.255.255.128",
	        26 => "255.255.255.192",
	        27 => "255.255.255.224",
	        28 => "255.255.255.240",
	        29 => "255.255.255.248",
	        30 => "255.255.255.252",
	        31 => "255.255.255.254",
	        32 => "255.255.255.255");
	        
	public function isValid($value)
	{
		// Solo se permiten netmasks de 24 a 32 (Clase C) - http://es.wikipedia.org/wiki/M%C3%A1scara_de_red        
		$this->_setValue($value);
		if(($value >= self::MIN_MASK) && ($value <= self::MAX_MASK)) return true;
	        
		for($i=self::MIN_MASK; $i <= self::MAX_MASK; $i++) {
			if($this->_netmasks[$i] == $value) return true;
		}
		$this->_error(self::INVALID);
	    return false;
	}

}