<?php

class VSCAN_Validate_DateAfterNow extends Zend_Validate_Abstract {
	
	const OUT_OF_THE_RANGE      = 'OutOftherange';
  //const MINUTES_OFFSET 		= 10;
  const MINUTES_OFFSET 		= 0;
	protected $_options = array();
	protected $_messageTemplates = array(
        //self::OUT_OF_THE_RANGE      => "The scan date should be 10 minutes greater than the current date",
				self::OUT_OF_THE_RANGE      => "The scan date should be greater that the current date time",
    );
    
	public function isValid($value)
	{
		if (empty($value)) return false;
		$this->_setValue($value);
		if (!Zend_Date::isDate($value)) return false;
		$date = new Zend_Date($value);
		$company_id = VSCAN_Sessions::getCurrentCompany();
		$company = new VSCAN_Model_Company();
		$company->find($company_id);
		$timezone = $company->getTimezone();

		$now = new Zend_Date();

		$now = VSCAN_Locale::convertDateByOffset($now, $timezone);
	
		$now->addMinute(self::MINUTES_OFFSET); 
		if ($date->isEarlier($now)){
			$this->_error(self::OUT_OF_THE_RANGE);
			return false;	
		} 
		return true;
		
	}

}
