<?php
/**
 * webservice handler
 */
class VSCAN_WS_Scans extends VSCAN_WS_abstract {
	
	const OK = 0;
	const ERROR = 1;
	const KEY_FOR_CHECK = 'codigo';
	
	public function __construct($soapVersion = SOAP_1_1, $url = null ){
		if (is_null($url)){
			$url = Zend_Registry::get('config')->ws->url;
		}
		parent::__construct($soapVersion, $url);
	}
	
	/**
	 * 
	 * Execute Scan by webservice
	 * @param string $id
	 * @param string $companyName
	 * @param string $type FULLSCAN | CUSTOMSCAP
	 * @param array $aTargets targets
	 * @return boolean
	 */
	public function VScan($id, $companyName, $type, array $aTargets) {
			
		for ($i=0; $i<3; $i++) {
			$ret = $this->_soap->VScan($id, $companyName, $type, $aTargets);
			if (is_array($ret) && isset($ret[self::KEY_FOR_CHECK])) 
				if ($ret[self::KEY_FOR_CHECK] == self::OK)
					return $ret[VSCAN_Scan::UUID];
		}
		return false;
	}
	/**
	 * 
	 * stop Scan by webservice
	 * @param string $uuid
	 * @param string $companyName
	 * @return boolean
	 */
	public function Stop($uuid, $companyName) {
		
		/** Workaround FGM, WS returns a int not an array **/	
		//for ($i=0; $i<3; $i++) {
			$ret = $this->_soap->ManageScan($uuid, $companyName, 'stop');
			if (is_array($ret) && isset($ret[self::KEY_FOR_CHECK])) 
				if ($ret[self::KEY_FOR_CHECK] == self::OK)
					return $ret[VSCAN_Scan::UUID];
		//}
		return false;
	}
	


}