var STATUS_RUNNING = 'running'
var READY_FOR_SCAN = 'ready_for_scan'
$(document).ready(function(){
	$.extend($.datepicker,{_checkOffset:function(inst,offset,isFixed){return offset}});
	$.extend($.datepicker,{_gotoToday:function(id){	
		var inst = this._getInst($(id)[0]),
		$dp = inst.dpDiv;
		this._base_gotoToday(id);
		var now = new Date();
		//adding 11 minutes
		now.setMinutes(now.getMinutes() + 1);
		//now.setMinutes(now.getMinutes() + 11);
		var tp_inst = this._get(inst, 'timepicker');
		if (tp_inst && tp_inst._defaults.showTimezone && tp_inst.timezone_select) {
			var tzoffset = now.getTimezoneOffset(); // If +0100, returns -60
			var tzsign = tzoffset > 0 ? '-' : '+';
			tzoffset = Math.abs(tzoffset);
			var tzmin = tzoffset % 60;
			tzoffset = tzsign + ('0' + (tzoffset - tzmin) / 60).slice(-2) + ('0' + tzmin).slice(-2);
			if (tp_inst._defaults.timezoneIso8609)
				tzoffset = tzoffset.substring(0, 3) + ':' + tzoffset.substring(3);
			tp_inst.timezone_select.val(tzoffset);
		}
		this._setTime(inst, now);
		$( '.ui-datepicker-today', $dp).click();
	}});
	
	$('#date').datetimepicker({timeFormat: 'hh:mm TT',ampm: true});


});

//Recheck 
$(document).ready(function(){
	//display tooltip for vulnerability
	$('span[rel="tooltip"]').tooltip();

	Recheck.bind_submit_for_show_checkbox();
	Recheck.bind_hover_recheck($('.accordion-heading'));
	Recheck.bind_hover_omit($('.accordion-heading'));
	$('button.recheck').click(Recheck.recheckAjax);

	$('button.omit').click(function (e){
			e.preventDefault();
			var $loading = $('<div class="loading-right"></div>');
			$(this).hide();
			$(this).parent().find('span.recheck').hide();
			$(this).parent().find('button').hide()
			$(this).after($loading);
			var url = $(this).data('href');
			var $a = $(this);
			$.ajax({
				url: url,
				dataType: 'json',
				success: function (response){
					console.log('omit', response);
					$a.parent().find('#status_label').html(STATUS_RUNNING);
					$a.parent().find('#vul_status').html(STATUS_RUNNING);
					$a.parent().find('span.recheck').remove();
					$a.remove();
				},
				error: function(res, status, error){
					
					var message = res.responseText;
					if (message == ""){
						message = "Still Working..."
					} else{
						$a.show();
						$a.parent().find('span.recheck').show();
						$a.parent().find('.loading-right').remove();
					}
					
					if (!Application.is_flash_message_displayed()) {
						Application.show_flash_message(Application.flash_type.warning, message, '.span8');
					}
					
				}
			})
		});

	// get recheck results
	setInterval(function(){
		$("div.hidden:contains('"+ STATUS_RUNNING + "'), div.hidden:contains('"+ READY_FOR_SCAN + "')").each(function (i, elem){
			var vulId = $(elem).parent().find('#vul_id').html();
			$.ajax({
				url: '/vulnerability/vulstatus/id/'+vulId,
				dataType: 'json',
				success: function (response){
					if ((response.status != STATUS_RUNNING || response.status != READY_FOR_SCAN) && response.detail_html != ''){
						$("div.hidden:contains('"+ vulId + "')").parent().parent().html($(response.detail_html).html());

						$row = $("div.hidden:contains('"+ vulId + "')").parent().parent();
						$row.find('button.recheck').click(Recheck.recheckAjax);
						Recheck.bind_hover_recheck($row.find('.accordion-heading'));
						Recheck.update_risk($row.find('.accordion-heading'), response.detail_html);
					}
					console.log(response);
				},
				error: function(res, status, error){
					console.log('error',res);
				}
			});
		})
		},5000);

});

Recheck = {
		recheckAjax: function (e){
			e.preventDefault();
			var $loading = $('<div class="loading-right"></div>');
			$(this).hide();
			$(this).parent().find('span.recheck').hide();
			$(this).parent().find('button').hide();
			$(this).after($loading);
			var url = $(this).data('href');
			var $a = $(this);
			$.ajax({
				url: url,
				dataType: 'json',
				success: function (response){
					$a.parent().find('#status_label').html(STATUS_RUNNING);
					$a.parent().find('#vul_status').html(STATUS_RUNNING);
					$a.parent().find('span.recheck').remove();
					$a.remove();
				},
				error: function(res, status, error){
					
					var message = res.responseText;
					if (message == ""){
						message = "Still Working..."
					} else{
						$a.show();
						$a.parent().find('span.recheck').show();
						$a.parent().find('.loading-right').remove();
					}
					
					if (!Application.is_flash_message_displayed()) {
						Application.show_flash_message(Application.flash_type.warning, message, '.span8');
					}
					
				}
			})
		},

		bind_hover_recheck: function(elem){
			$(elem).hover(
			function(){
				if ($(this).parent().find('.loading-right').length == 0){
					$(this).find('button.recheck').show();
				}
				
			},
			function(){
				$(this).find('button.recheck').hide();
			})
		},
		bind_hover_omit: function(elem){
			$(elem).hover(
			function(){
				if ($(this).parent().find('.loading-right').length == 0){
					$(this).find('button.omit').show();
				}
			},
			function(){
				$(this).find('button.omit').hide();
			})
		},
		bind_submit_for_show_checkbox: function(){
			$('#chk_show_solved').change(function(){
				if($(this).is(':checked')){
					$('#show_solved').val('1');
				} else {
					$('#show_solved').val('0');
				}
				this.form.submit();
			});
		},
		update_risk: function (elem, risk){
			//TODO: change the color and the name of the risk level
			//console.log(elem, risk);
		}
}

