<?php

/*
* Copyright 2012-2013 Federico Massa
*
* This file is part of VScan.
*
* VScan is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero General Public License, version 3,
* as published by the Free Software Foundation.
*
* VScan is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU Affero General Public License for more details.
*
* You should have received a copy of the GNU Affero General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

// Version: 5.0
// Requires: mail, nessus, libapache2-mod-php5 (apache y php5), php5-curl

// ----- CONFIGURATION -----

// PRODUCCION
$entorno = "PRODUCTION";
$blocklan = "SI"; // Poner en "SI" para habilitar el bloqueo de IP internas, "NO" para no bloquear ningun tipo de IP.
$alertas = "alertas@localhost"; // Correos o alias que reciben las alertas

$application_path = "/var/www/vscan-blackhat.vanguardsec.com";
$nessus_server = "https://127.0.0.1:8834";
$username = "";
$password = "";
$nusoap_path = $application_path."/library/nusoap/lib/nusoap.php";
$nessus_plugin_list = $application_path."/data/nessus_plugin_list";
$common_ports = "21,22,25,80,110,443"; // Puertos utilizados por CustomScan

// ----- END CONFIGURATION -----

require_once($nusoap_path);

function ManageScan($uuid,$company,$action)
{
	 // Validacion de $idproces,$company y $action (stop,pause,resume)
        #$idproceso = filter_var($idproceso, FILTER_SANITIZE_STRING); // Sanitization de $idproceso
       	#$idproceso = intval($idproceso); // Esto se utiliza por ahora ya que la aplicacion envia idproceso como STRING
        $company = filter_var($company, FILTER_SANITIZE_STRING); // Sanitization de $company

        #if(($action != "stop") && ($action != "pause") && ($action != "resume")) return 1; // Validacion de $action
        if($action != "stop") return 1; // Validacion de $action

        $random = mt_rand();
        $auth_token = CreateNessusSession($random);

        if(!$auth_token)
        {
                $desc = "FullScan $idproceso, $company: error to stop the scan, invalid autk_token value";
                SendMail($desc,$salida);
                return 1;
        }

        global $nessus_server;

	// Stop/Pause/Resume scan
        $conn = curl_init($nessus_server . "/scan/$action");
        $post_data = array("scan_uuid" => $uuid, "seq" => $random);
        curl_setopt($conn,CURLOPT_CONNECTTIMEOUT, 30);
        curl_setopt($conn,CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($conn,CURLOPT_SSL_VERIFYHOST, 1);
        curl_setopt($conn,CURLOPT_RETURNTRANSFER, true);
        curl_setopt($conn,CURLOPT_COOKIE, "token=$auth_token");
        curl_setopt($conn,CURLOPT_POST, true);
        curl_setopt($conn,CURLOPT_POSTFIELDS, $post_data);
        $result = curl_exec($conn);
        curl_close($conn);

        // Flag para saber si el scan fue detenido
        #$file = fopen("/tmp/vscan.$idproceso.stop", 'w');
        #fclose($file);
	$desc = "FullScant STOPPED - $company - $uuid";
        SendMail($desc);
	
	# VALIDAR EL RETORNO DE STOP
        return 0;
}

function CreateNessusSession($random)
{
	global $nessus_server;
	global $username;
	global $password;
	
	$conn = curl_init($nessus_server . "/login" );
	$post_data = array("login" => $username, "password" => $password, "seq" => $random);
	curl_setopt($conn,CURLOPT_CONNECTTIMEOUT, 30);
	curl_setopt($conn,CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($conn,CURLOPT_SSL_VERIFYHOST, 1);
	curl_setopt($conn,CURLOPT_RETURNTRANSFER, true);
	curl_setopt($conn,CURLOPT_POST, true);
	curl_setopt($conn,CURLOPT_POSTFIELDS, $post_data);
	$xmlresponse = simplexml_load_string(curl_exec($conn));
	$auth_token = $xmlresponse->contents->token;
	$xmlresponse = null;
	curl_close($conn);
	
	return $auth_token;
}

function DownloadPolicy($auth_token,$scantype,$random)
{
	global $nessus_server;
	
	$conn = curl_init($nessus_server . "/policy/list");
	$post_data = array("seq" => $random);
	curl_setopt($conn,CURLOPT_CONNECTTIMEOUT, 30);
	curl_setopt($conn,CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($conn,CURLOPT_SSL_VERIFYHOST, 1);
	curl_setopt($conn,CURLOPT_RETURNTRANSFER, true);
	curl_setopt($conn,CURLOPT_COOKIE, "token=$auth_token");
	curl_setopt($conn,CURLOPT_POST, true);
	curl_setopt($conn,CURLOPT_POSTFIELDS, $post_data);
	$xmlresponse = simplexml_load_string(curl_exec($conn));
	curl_close($conn);

	// Genero una Policy compatible con Nessus (para que funcione el upload de la policy)
	$file = fopen("/tmp/vscan$random.nessus.tmp", "w");
	fwrite($file, $xmlresponse->asXML());
	fclose($file);
	$xmlresponse = null;

	// VALIDAR QUE SE ENCONTRO LA POLICY
	$library = new SimpleXMLElement("/tmp/vscan$random.nessus.tmp",null,true);
	if($scantype == "FullScan")
	{
		$policy = $library->xpath("/reply/contents/policies/policy[policyName='VScanFullScan']");
	}
	else
	{
		$policy = $library->xpath("/reply/contents/policies/policy[policyName='VScanCustomScan']");
	}
	unset($policy[0]->policyID);
	$file2 = fopen("/tmp/vscan$random.nessus.tmp", "w");
	fwrite($file2, $policy[0]->asXML());
	fclose($file2);
	`echo "<NessusClientData_v2>" > /tmp/vscan$random.nessus`;
	`cat /tmp/vscan$random.nessus.tmp | sed 's/<policy>/<Policy>/g' | sed 's/<\/policy>/<\/Policy>/g' >> /tmp/vscan$random.nessus`;
	`echo "</NessusClientData_v2>" >> /tmp/vscan$random.nessus`;

	return 0;
}

function UploadPolicy($policy,$auth_token,$random)
{
	global $nessus_server;

	// Workaround para que funcione el upload en PHP 5.3 (tiene que estar en el mismo directorio que el script, investigar !!!)
	$dirscript = dirname(__FILE__);
        `cp $policy $dirscript`;
        $policy = basename($policy);
	
	// Upload file containing policy
	$conn = curl_init($nessus_server . "/file/upload");
	$post_data = array("Filedata" => "@$policy");
	curl_setopt($conn,CURLOPT_CONNECTTIMEOUT, 30);
	curl_setopt($conn,CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($conn,CURLOPT_SSL_VERIFYHOST, 1);
	curl_setopt($conn,CURLOPT_RETURNTRANSFER, true);
	curl_setopt($conn,CURLOPT_COOKIE, "token=$auth_token");
	curl_setopt($conn,CURLOPT_POST, true);
	curl_setopt($conn,CURLOPT_POSTFIELDS, $post_data);
	$result = curl_exec($conn);

	// Import policy from uploaded file
	$conn = curl_init($nessus_server . "/file/policy/import");
	$post_data = array("seq" => $random,"file" => "vscan$random.nessus");
	curl_setopt($conn,CURLOPT_CONNECTTIMEOUT, 30);
	curl_setopt($conn,CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($conn,CURLOPT_SSL_VERIFYHOST, 1);
	curl_setopt($conn,CURLOPT_RETURNTRANSFER, true);
	curl_setopt($conn,CURLOPT_COOKIE, "token=$auth_token");
	curl_setopt($conn,CURLOPT_POST, true);
	curl_setopt($conn,CURLOPT_POSTFIELDS, $post_data);
	$result = curl_exec($conn);
	curl_close($conn);
	
	// Workaround para que funcione el upload en PHP 5.3 (tiene que estar en el mismo directorio que el script, investigar !!!)
	`rm $policy`;
	
	return 0;
}

function GetPolicyID($policyname,$auth_token)
{
	global $nessus_server;
	
	$conn = curl_init($nessus_server . "/policy/list");
        curl_setopt($conn,CURLOPT_CONNECTTIMEOUT, 30);
        curl_setopt($conn,CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($conn,CURLOPT_SSL_VERIFYHOST, 1);
        curl_setopt($conn,CURLOPT_RETURNTRANSFER, true);
        curl_setopt($conn,CURLOPT_COOKIE, "token=$auth_token");
	$xmlresponse = simplexml_load_string(curl_exec($conn));
	$xmlresponsetmp = $xmlresponse->xpath("/reply/contents/policies/policy[policyName='$policyname']");
        $policyid = $xmlresponsetmp[0]->policyID;
	$xmlresponsetmp = null;
	$xmlresponse = null;
        curl_close($conn);
	
	return $policyid;
}

function CheckWANConnection()
{
	$checkwan = @fsockopen("www.google.com", 80, $errno, $errstr, 4);
    	if($checkwan)
	{
        	fclose($checkwan);
		return 0;
	}
    	return 1;
}

function CountTargets($ttarget,$start,$end)
{
        $canttargets = 0;
	if($ttarget == "range")
	{
        	$array1 = explode(".", $start);
        	$array2 = explode(".", $end);
        	$a1 = $array1[0]; $b1 = $array1[1]; $c1 = $array1[2]; $d1 = $array1[3];
        	$a2 = $array2[0]; $b2 = $array2[1]; $c2 = $array2[2]; $d2 = $array2[3];
        	while($d2 >= $d1 || $c2 > $c1 || $b2 > $b1 || $a2 > $a1)
        	{
                	if($d1 > 255)
                	{
                        	$d1 = 1;
                        	$c1 ++;
                	}
                	if($c1 > 255)
                	{
                        	$c1 = 1;
                        	$b1 ++;
                	}
                	if($b1 > 255)
                	{
                        	$b1 = 1;
                        	$a1 ++;
                	}
                	$d1 ++;
                	$canttargets ++;
        	}
	}
	if($ttarget == "network")
	{
		switch($end)
		{
			case ($end == "32" || $end == "255.255.255.255"):
                        	$canttargets = 1;
                        	break;
			case ($end == "31" || $end == "255.255.255.254"):
                                $canttargets = 2;
                                break;
			case ($end == "30" || $end == "255.255.255.252"):
                                $canttargets = 4;
                                break;
			case ($end == "29" || $end == "255.255.255.248"):
                                $canttargets = 8;
                                break;
			case ($end == "28" || $end == "255.255.255.240"):
                                $canttargets = 16;
                                break;
			case ($end == "27" || $end == "255.255.255.224"):
                                $canttargets = 32;
                                break;
			case ($end == "26" || $end == "255.255.255.192"):
                                $canttargets = 64;
                                break;
			case ($end == "25" || $end == "255.255.255.128"):
                                $canttargets = 128;
                                break;
			case ($end == "24" || $end == "255.255.255.0"):
                                $canttargets = 256;
                                break;
			case ($end == "23" || $end == "255.255.254.0"):
				$canttargets = 512;
                                break;
		}
	}
	if(($ttarget == "hostname") || ($ttarget == "webapp")) $canttargets = 1;
        return $canttargets;
}

function ValidateIP($ip)
{
        global $blocklan;
	if(filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4))
	{
        	if($blocklan == "SI")
                {
			if(filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE))
			{
				if($ip == "127.0.0.1") return 1; // La IP es localhost
				return 0;
			}
			return 1; // La IP es privada
                }
                return 0; // SI es una IP o un Dominio valido
        }
        return 1; // NO es una IP ni un Dominio valido
}

function ValidateDomain($ip)
{
        $retorno = ValidateIP($ip);
        if($retorno == 1)
        {
		$dnsr = @dns_get_record("$ip", DNS_A);
                $ipr = $dnsr[0][ip];
                if($ipr)
                {
                        return ValidateIP($ipr); // El dominio existe y es valido
                }
        }
        return $retorno; // El domino es invalido
}

function ValidateNetmask($mask)
{
	$netmaskarray = array(1 => "128.0.0.0",
        2 => "192.0.0.0",
        3 => "224.0.0.0",
        4 => "240.0.0.0",
        5 => "248.0.0.0",
        6 => "252.0.0.0",
        7 => "254.0.0.0",
        8 => "255.0.0.0",
        9 => "255.128.0.0",
        10 => "255.192.0.0",
        11 => "255.224.0.0",
        12 => "255.240.0.0",
        13 => "255.248.0.0",
        14 => "255.252.0.0",
        15 => "255.254.0.0",
        16 => "255.255.0.0",
        17 => "255.255.128.0",
        18 => "255.255.192.0",
        19 => "255.255.224.0",
        20 => "255.255.240.0",
        21 => "255.255.248.0",
        22 => "255.255.252.0",
        23 => "255.255.254.0",
        24 => "255.255.255.0",
	25 => "255.255.255.128",
        26 => "255.255.255.192",
        27 => "255.255.255.224",
        28 => "255.255.255.240",
        29 => "255.255.255.248",
        30 => "255.255.255.252",
        31 => "255.255.255.254",
        32 => "255.255.255.255");
        
	// Solo se permiten netmasks de 24 a 32 (Clase C) - http://es.wikipedia.org/wiki/M%C3%A1scara_de_red
	if(($mask >= 24) && ($mask <= 32)) return 0;
        
	for($i=24; $i <= 32; $i++)
        {
                if($netmaskarray[$i] == $mask) return 0;
        }
        return 1;
}

// WebService de validacion de Targets
function ValidateTarget($ttarget,$start,$end)
{
	if($ttarget == "hostname")
	{
		return ValidateDomain($start);
	}
	if($ttarget == "range")
	{
		if((ValidateIP($start) == 0) && (ValidateIP($end) == 0) && (ip2long($start) < ip2long($end))) return 0;
	}
	if($ttarget == "network")
	{
		if((ValidateIP($start) == 0) && (ValidateNetmask($end) == 0)) return 0;
	}
	/*
	if($ttarget == "webapp")
        {
		return ValidateDomain($start);
        }
	return 1;
	*/
}

function AddTarget($scantype,$target,$targetslistfile,$policy)
{
	if($target['type'] == "hostname")
    	{
		// Validar que Start sea una IP o un HostName
		$vip = ValidateTarget($target['type'],$target['start'],0);
        	if($vip != 0) return $vip;
		fwrite($targetslistfile, $target['start'].",");
		`echo "\nType: $target[type]\nHost/IP: $target[start]" >> $policy.stdout`;
    	}
    	if($target['type'] == "range")
    	{
		// Validar que Start sea menor que End y que ambos sean direcciones IP
		$vip = ValidateTarget($target['type'],$target['start'],$target['end']);

		fwrite($targetslistfile, $target['start']."-".$target['end'].",");
		`echo "\nType: $target[type]\nStart: $target[start]\nEnd: $target[end]" >> $policy.stdout`;
    	}
	if($target['type'] == "network")
    	{
		// Validar que Start sea una IP y End sea una Netmask
		$vip = ValidateTarget($target['type'],$target['start'],$target['end']);
        	if($vip != 0) return $vip;
		fwrite($targetslistfile, $target['start']."/".$target['end'].",");
		`echo "\nType: $target[type]\nNetwork: $target[start]\nNetmask: $target[end]" >> $policy.stdout`;
    	}
	
        if($scantype == "CustomScan")
        {
		`echo "PlugnID: $target[pluginid]\nPort: $target[port]" >> $policy.stdout`;
	
                if(!filter_var($target['pluginid'], FILTER_VALIDATE_INT))
                {
                	return 2; // NO es un entero
                }

                // Get and add Plugin info - Ver si el get se puede hacer mediante Nessus XML-RPC o al menos PHP
                global $nessus_plugin_list;
                $pluginsearchtmp = `cat $nessus_plugin_list | grep $target[pluginid]\|`;
                $pluginsearch = $rest = substr($pluginsearchtmp, 0, -1); // Se elimina el ultimo caracter porque esta en blanco
		$pluginreturn = explode("|", $pluginsearch);
		
                `echo "PluginName: $pluginreturn[2]\nFamily: $pluginreturn[1]" >> $policy.stdout`;

		if($target['pluginid'] != $pluginreturn[0])
                {
			return 3; // Plugin ID no encontrado
		}
                else
                {
			$xmlpolicy = simplexml_load_file($policy);
                	
			// Enable Ports
                	global $common_ports;
			$xmlpolicytmp = $xmlpolicy->xpath("/NessusClientData_v2/Policy/policyContents/Preferences/ServerPreferences/preference[name='port_range']");
                	if($target['port'] == 0)
                	{
                		$xmlpolicytmp[0]->value = $common_ports;
                	}
			else
                	{
                		$xmlpolicytmp[0]->value = $target['port'];
				// Workaround porque algunos plugins dan falso negativo
                		//$xmlpolicytmp[0]->value = $target['port'].",".$common_ports;
                	}

                	// Enable Plugin and Plugin partial family
			$xmlpolicytmp = $xmlpolicy->xpath("/NessusClientData_v2/Policy/policyContents/FamilySelection/FamilyItem[FamilyName='$pluginreturn[1]']");
			
			// Workaround porque algunos plugins dan falso negativo
			if(($pluginreturn[1] == "CGI abuses") || ($target['pluginid'] == 20094) || ($target['pluginid'] == 33447) || ($target['pluginid'] == 34460) || ($target['pluginid'] == 42479) || ($target['pluginid'] == 45411) || ($target['pluginid'] == 47831) || ($target['pluginid'] == 57640))
			{
				$xmlpolicytmp[0]->Status = "enabled";
				$xmlpolicytmp = $xmlpolicy->xpath("/NessusClientData_v2/Policy/policyContents/Preferences/ServerPreferences/preference[name='unscanned_closed']");
				$xmlpolicytmp[0]->value = "no";
			}
			else
			{
				$xmlpolicytmp[0]->Status = "mixed";
				$addtarget = $xmlpolicy->Policy->policyContents->IndividualPluginSelection->addChild('PluginItem');
                        	$addtarget->addChild('PluginId', $pluginreturn[0]);
                        	$addtarget->addChild('PluginName', $pluginreturn[2]);
                        	$addtarget->addChild('Family', $pluginreturn[1]);
                        	$addtarget->addChild('Status', 'enabled');
			}
		
			$file = fopen("$policy", "w");
                	fwrite($file, $xmlpolicy->asXML());
                	fclose($file);
			$xmlpolicy = null;
		}
        }
	return 0;
}

function SendMail($subject,$body)
{
	global $entorno;
	global $alertas;
	if(file_exists($body))
	{
		`mail -s "$entorno - $subject" $alertas < $body`;
	}
	else
	{
		`mail -s "$entorno - $subject" $alertas`;
	}
	return 0;
}

function RemoveTMP($policy)
{
	// Esto es para evitar que se llene de basura /tmp
        #`rm $policy*`;
        return 0;
}

// WebService principal
function VScan($idproceso,$company,$scantype,$targets)
{
	// Validacion/Sanitization inicial de $idproceso y $company
	$idproceso = filter_var($idproceso, FILTER_SANITIZE_STRING); // Sanitization de $idproceso
	$idproceso = intval($idproceso); // Esto se utiliza por ahora ya que la aplicacion envia idproceso como STRING
	$company = filter_var($company, FILTER_SANITIZE_STRING); // Sanitization de $company

	// Definicion de los archivos de policy, salida, error y targetslist
	$random = mt_rand();
	$policy = "/tmp/vscan".$random.".nessus";
        $salida = "$policy.stdout";
        $error = "$policy.stderr";
        $targetslist = "$policy.targets";
	`echo "- IDScan: $idproceso\n- Company: $company\n- Policy: $policy\n" >> $salida`;
	
	// Validacion de $scantype
	if(($scantype != "FullScan") && ($scantype != "CustomScan"))
	{
		`echo "Invalid scantype value\n\n" >> $error`;
                `cat $salida >> $error`;

                $codigo = 1;
                $desc = "FullScan/CustomScan $random ERROR";

                SendMail($desc,$error);
                RemoveTMP($policy);
                return array($codigo,$desc);
	}
	
	// Obtener Token
        $auth_token = CreateNessusSession($random);
	// Validacion de $auth_token
	if(!$auth_token)
	{
		`echo "Invalid autk_token value\n\n" >> $error`;
                `cat $salida >> $error`;

                $codigo = 1;
                $desc = "$scantype $random ERROR";

                SendMail($desc,$error);
                RemoveTMP($policy);
                return array($codigo,$desc);
	}
	
	// Si es CustomScan descargo la policy y verifco si se descargo correctamente
	if($scantype == "CustomScan")
	{
		DownloadPolicy($auth_token,$scantype,$random);
		if(!file_exists($policy))
		{
			`echo "Error in Web Service: Policy file not found\n\n" >> $error`;
               		`cat $salida >> $error`;
                
			$codigo = 1;
                	$desc = "$scantype $random ERROR";

                	SendMail($desc,$error);
                	RemoveTMP($policy);
                	return array($codigo,$desc);
        	}
	}

	// Obtenemos la lista de Targets, los validamos, los contamos y los guardamos en un archivo
	`echo "- Targets:" >> $salida`;
	$targetslistfile = fopen($targetslist, "w");
	// Estas 2 variables se utilizan solo para CustomScan y se inicializan en 1 para que funcione el FullScan
	//$reporthostcod = 1;
	//$reporthostitem = 1;
	$canttargetstotal = 0;
	
	foreach($targets as $target)
                {
                        /*
			if($scantype == "CustomScan")
                        {
                                $reporthostcod = $target['reporthostcod'];
                                $reporthostitem = $target['reporthostitem'];
                        }
			*/

                        $addtrt = 0;
                        $addtrt = AddTarget($scantype,$target,$targetslistfile,$policy);
                        $canttargetstotal = $canttargetstotal + CountTargets($target['type'],$target['start'],$target['end']);
                        if($addtrt != 0)
                        {
                                switch($addtrt)
                                {
                                        case($addtrt == 1):
                                                `echo "Error in Web Service: Invalid Host Name or IP Address: Type: $target[type], Start: $target[start], End: $target[end]\n\n" >> $error`;
						break;
                                        case($addtrt == 2):
                                                `echo "Invalid pluginid value\n\n" >> $error`;
						break;
                                        case($addtrt == 3):
                                                `echo "Error in Web Service: Plugin not found (verify nessus_plugin_list)\n\n" >> $error`;
						break;
                                }

                                `cat $salida >> $error`;
                                $desc = "$scantype $random ERROR";

                                SendMail($desc,$error);
                                $addtrt = 1; // VER - Contemplar distintos valores de retorno en la app principal
                                RemoveTMP($policy);
                                return array($addtrt,$desc);
                        }
                }

	fclose($targetslistfile);
		
	// Verificar cantidad de targets
	#if(($canttargetstotal > 512) || ($canttargetstotal == 0))
	if($canttargetstotal > 512)
        {
               	#`echo "Error in Web Service: Invalid number of targets (0 hosts or more than 512 hosts). Total:$canttargetstotal\n\n" >> $error`;
               	`echo "Error in Web Service: Invalid number of targets (more than 512 hosts). Total:$canttargetstotal\n\n" >> $error`;
		`cat $salida >> $error`;
		
		$codigo = 1;
                $desc = "$scantype $random ERROR";

                SendMail($desc,$error);
                RemoveTMP($policy);
                return array($codigo,$desc);
	}
	
	// Verificar si la conexion WAN esta OK
	if(CheckWANConnection() == 1)
	{
	        `echo "Error in Web Service: WAN Connection Down\n\n" >> $error`;
                `cat $salida >> $error`;

                $codigo = 1;
                $desc = "$scantype $random ERROR";

                SendMail($desc,$error);
                RemoveTMP($policy);
                return array($codigo,$desc);
	}
		
	// Si el target es CustomScan subir la policy customizada, luego obtener la policy_id
	//if((file_exists("$policy.webapp")) || ($scantype == "CustomScan"))
	if($scantype == "CustomScan")
	{
		$xmlpolicy = simplexml_load_file($policy);
		$xmlpolicy->Policy->policyName = "$scantype-$idproceso";
		$file = fopen("$policy", "w");
          	fwrite($file, $xmlpolicy->asXML());
         	fclose($file);
		$xmlpolicy = null;
			
		UploadPolicy($policy,$auth_token,$random);
		$policyid = GetPolicyID("$scantype-$idproceso",$auth_token);
		
		$scan_name = "$company - VA: $idproceso - Custom Scan - PluginID: $target[pluginid]";
		/*
		if($scantype == "CustomScan")
		{
			$scan_name = "$company  - VA: $idproceso - Custom Scan - PluginID: $target[pluginid]";
		}
		else
		{
			$scan_name = "$company  - VA: $idproceso";
		}
		*/
		
		// Esto se utiliza para eliminar la policy al finalizar el escaneo (solo SI los target contienen una WebApp o es un CustomScan)
		// SE VA A SACAR
                $deletepolicy = $policyid;
	}
	else
	{
		$policyid = GetPolicyID("VScanFullScan",$auth_token);
		$scan_name = "$company - VA: $idproceso";
				
		// Esto se utiliza para NO eliminar la policy al finalizar el escaneo (solo SI los target NO contienen una WebApp o NO es un CustomScan)
		// SE VA A SACAR
		$deletepolicy = 0;
	}
	`echo "\n- PolicyID: $policyid" >> $salida`;

	// Obtener los targets previamente guardados
	$targetslistfile = fopen($targetslist, "r");
	$tlfcontent = fread($targetslistfile, filesize($targetslist));
	fclose($targetslistfile);
	
	// Ejecutamos el scan !!!		
	global $nessus_server;
	global $sendscan;
	$post_data = array("target" => $tlfcontent, "policy_id" => $policyid, "scan_name" => $scan_name);
	$conn = curl_init($nessus_server . "/scan/new");
       	curl_setopt($conn,CURLOPT_CONNECTTIMEOUT, 30);
       	curl_setopt($conn,CURLOPT_SSL_VERIFYPEER, false);
       	curl_setopt($conn,CURLOPT_SSL_VERIFYHOST, 1);
       	curl_setopt($conn,CURLOPT_RETURNTRANSFER, true);
       	curl_setopt($conn,CURLOPT_POST, true);
       	curl_setopt($conn,CURLOPT_POSTFIELDS, $post_data);
	curl_setopt($conn,CURLOPT_COOKIE, "token=$auth_token");
	$xmlresponse = simplexml_load_string(curl_exec($conn));
       	$uuid = $xmlresponse->contents->scan->uuid;
       	$xmlresponse = null;
       	curl_close($conn);
        $fecha = getdate();
	`echo "- UUID: $uuid\n- PolicyID to delete (only if not 0): $deletepolicy\n- Start Date: $fecha[mday]/$fecha[mon]/$fecha[year] - $fecha[hours]:$fecha[minutes]:$fecha[seconds]" >> $salida`;
			
	// Llamamos a sendscan para que verifique si finalizo el scan y envie los resultados
	#exec("php $sendscan $scantype $idproceso $uuid $random $deletepolicy $reporthostcod $reporthostitem >> $error 2>&1 &");
			
	// Esperar a que sendscan no devuelva errores
	sleep(5);
	$errorcontent = filesize("$error");
			
	if($errorcontent == 0)
	{
		$codigo = 0;
              	$desc = "$scantype $random Running";

		SendMail($desc,$salida);
	}
	else
	{
		// Detener Scan y eliminar policy
		`cat $salida >> $error`;

		$codigo = 1;
		$desc = "$scantype $random ERROR";

		SendMail($desc,$error);
        	RemoveTMP($policy);
	}
        return array($codigo,$desc,$uuid);
}



// ----- WSDL -----
$server = new soap_server();
$ns="VScan";
$server->configurewsdl('TriggerService',$ns);
$server->wsdl->schematargetnamespace=$ns;

$server->register('VScan',
                          array('id' => 'xsd:string',
                                'company' => 'xsd:string',
				'scantype' => 'xsd:string', // FullScan or CustomScan
                                'targets' => 'tns:Targets'),array('codigo' => 'xsd:int',
                                                           'desc' => 'xsd:string',
							   'uuid' => 'xsd:string'),$ns);

$server->wsdl->addComplexType('Target', 'complexType', 'struct', 'all', '',
    array(
        'type' => array('name' => 'type', 'type' => 'xsd:string'),
        'start' => array('name' => 'start', 'type' => 'xsd:string'),
        'end' => array('name' => 'end', 'type' => 'xsd:string'),
	'pluginid' => array('name' => 'pluginid', 'type' => 'xsd:int'),
        'port' => array('name' => 'port', 'type' => 'xsd:int'),
    )
);

$server->wsdl->addComplexType('Targets', 'complexType', 'array', '',
    'SOAP-ENC:Array', array(),
    array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:Target[]')),
    'tns:Target');

/*
$server->register('ValidateTarget',
                          array('targettype' => 'xsd:string',
                                'start' => 'xsd:string',
                                'end' => 'xsd:string'),array('codigo' => 'xsd:int'),$ns);
                                                             #'desc' => 'xsd:string'),$ns);
*/

$server->register('ManageScan',
                          array('uuid' => 'xsd:string',
				'company' => 'xsd:string',
				'action' => 'xsd:string'),array('codigo' => 'xsd:int'),$ns);
// ----- Fin WSDL -----


if(isset($HTTP_RAW_POST_DATA))
{
    $input = $HTTP_RAW_POST_DATA;
}
else
{
    $input = implode("\r\n", file('php://input'));
}

$server->service($input);

exit;

?>
